-- By MaTiOs95
-- Programuje i skriptuje na zamowienie :P
-- www.polski-mod.cba.pl
-- Zetor 8145
-- 01.02.2011

MAT = {};

function MAT.prerequisitesPresent(specializations)
    return true;
end;

function MAT:load(xmlFile)
	local index = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.wal#index"));
	if index ~= nil then
		self.index = {};
		self.index.wal = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.wal#index"));
		self.index.klapka = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.klapka#index"));
		self.index.wzkazowka = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.wzkazowka#index"));
		self.index.sprzeglo = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.sprzeglo#index"));
		self.index.hamulec = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.hamulec#index"));
		self.index.gaz = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.gaz#index"));
		self.index.gaz2 = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.gaz2#index"));
		self.index.szyby = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.szyb#index"));
		self.index.drzwi1 = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.drzwi1#index"));
		self.index.drzwi2 = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.drzwi2#index"));
		self.index.kierun1 = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.kierun1#index"));
		self.index.kierun2 = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.kierun2#index"));
		self.index.halogen1 = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.halogen1#index"));
		self.index.halogen2 = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.halogen2#index"));
	end;
	self.predkosc = 0;
	self.szybkosc = 0;
	self.xp = 0;
	self.kier = 0;
	self.kier2 = 0;
end;

function MAT:delete()
end;

function MAT:mouseEvent(posX, posY, isDown, isUp, button)
end;

function MAT:keyEvent(unicode, sym, modifier, isDown)
	if isDown and sym == Input.KEY_KP_enter then
		self.odpal = not self.odpal;
	end;
	if sym == Input.KEY_s then
		self.keys = isDown;
	end;
	if sym == Input.KEY_w then
		self.keyw = isDown;
	end;
	if isDown and sym == Input.KEY_KP_4 then
		self.drzwi1 = not self.drzwi1;
	end;
	if isDown and sym == Input.KEY_KP_5 then
		self.szybka = not self.szybka;
	end;
	if isDown and sym == Input.KEY_KP_6 then
		self.drzwi2 = not self.drzwi2;
	end;
	if isDown and sym == Input.KEY_KP_1 then
		self.kierun1 = not self.kierun1;
		if self.kierun2 then
			self.kierun2 = not self.kierun2;
		end;
	end;
	if isDown and sym == Input.KEY_KP_3 then
		self.kierun2 = not self.kierun2;
		if self.kierun1 then
			self.kierun1 = not self.kierun1;
		end;
	end;
	if isDown and sym == Input.KEY_KP_8 then
		self.halogen1 = not self.halogen1;
	end;
	if isDown and sym == Input.KEY_KP_9 then
		self.halogen2 = not self.halogen2;
	end;
	if isDown and sym == Input.KEY_KP_0 then
		self.pomoc = not self.pomoc;
	end;
end;

function MAT:update(dt)
	for k,wheel in pairs(self.wheels) do
		self.predkosc = getWheelShapeAxleSpeed(wheel.node, wheel.wheelShape);
	end;
	local x1, y1, z1 = getRotation(self.index.wal);
	local x2, y2, z2 = getRotation(self.index.klapka);
	local x3, y3, z3 = getRotation(self.index.wzkazowka);
	local x4, y4, z4 = getTranslation(self.index.sprzeglo);
	local x5, y5, z5 = getTranslation(self.index.hamulec);
	local x6, y6, z6 = getRotation(self.index.gaz);
	local x7, y7, z7 = getRotation(self.index.gaz2);
	local x8, y8, z8 = getRotation(self.index.szyby);
	local x9, y9, z9 = getRotation(self.index.drzwi1);
	local x10, y10, z10 = getRotation(self.index.drzwi2);
	self.szybkosc = self.predkosc/1000;
	setRotation(self.index.wal, 0, 0, z1+self.szybkosc);
	
	if self.odpal then
		self:startMotor();
		self.steeringEnabled = true;
		
		if x2 > -0.16 then
			setRotation(self.index.klapka, x2-0.01, y2, z2);
		end;
		self.xp = self.xp + 1;
		if self.xp == 5 then
			setRotation(self.index.klapka, x2-0.03, y2, z2);
		end;
		if self.xp == 10 then
			setRotation(self.index.klapka, x2+0.03, y2, z2);
			self.xp = 0;
		end;
		
		self.wynik2 = self.predkosc*3.141593/1800;
		if self.predkosc > 30 then 
			self.wynik = self.wynik2 + 0.16;
			setRotation(self.index.klapka, -self.wynik, y2, z2);
		elseif self.predkosc < 30 then
			self.wynik = self.wynik2 - 0.16;
			setRotation(self.index.klapka, self.wynik*2, y2, z2);
		end;
		
		self.wynik3 = self.predkosc/140*3.141593/18*2;
		if self.predkosc > 0 then
			setRotation(self.index.wzkazowka, x3, -self.wynik3-0.08, z3);
		elseif self.predkosc < 0 then
			setRotation(self.index.wzkazowka, x3, self.wynik3-0.08*2, z3);
		end;
		if y3 > -0.08 then
			setRotation(self.index.wzkazowka, x3, y3-0.01, z3);
		end;
		
		if y6 > -0.349065 then
			setRotation(self.index.gaz, x6, y6-0.01, z6);
		end;
		
		local wynik = self.predkosc/23*3.141593/180;
		if self.predkosc > 0 then
			setRotation(self.index.gaz2, wynik, y7, z7);
		elseif self.predkosc < 0 then
			setRotation(self.index.gaz2, -wynik*2, y7, z7);
		end;		
	else
		self:stopMotor();
		self.steeringEnabled = false;
		
		if x2 < 0 then
			setRotation(self.index.klapka, x2+0.01, y2, z2);
		end;
		if y3 < 0 then
			setRotation(self.index.wzkazowka, x3, y3+0.01, z3);
		end;
		
		if y6 < 0 then
			setRotation(self.index.gaz, x6, y6+0.01, z6);
		end;
	end;
	
	if self.keys then
		if self.predkosc > 0 then
			if z5 < 0.1 then
				setTranslation(self.index.hamulec, x5, y5, z5+0.005);
			end;
		end;
	else
		if z5 > 0 then 
			setTranslation(self.index.hamulec, x5, y5, z5-0.005);
		end;
	end;
	if self.keyw then
		if self.predkosc < 0 then
			if z5 < 0.1 then
				setTranslation(self.index.hamulec, x5, y5, z5+0.005);
			end;
		end;
	else
		if z6 > 0 then
			setTranslation(self.index.hamulec, x5, y5, z5-0.005);
		end;
	end;
	if self.predkosc > -50 and self.predkosc < 50 then
		if z4 < 0.1 then
			setTranslation(self.index.sprzeglo, x4, y4, z4+0.005);
		end;
	else
		if z4 > 0 then
			setTranslation(self.index.sprzeglo, x4, y4, z4-0.005);
		end;
	end;
		
	if self.drzwi1 then
		if y9 > -3.37 then
			setRotation(self.index.drzwi1, x9, y9-0.01, z9);
		end;
	else
		if y9 < 0 then
			setRotation(self.index.drzwi1, x9, y9+0.01, z9);
		end;
	end;
	if self.drzwi2 then
		if y10 < 3.37 then
			setRotation(self.index.drzwi2, x10, y10+0.01, z10);
		end;
	else
		if y10 > 0 then
			setRotation(self.index.drzwi2, x10, y10-0.01, z10);
		end;
	end;
	
	if self.kierun1 then
		self.kier = self.kier+1;
		if self.kier == 20	then
			setVisibility(self.index.kierun1, true);
		elseif self.kier == 40 then
			setVisibility(self.index.kierun1, false);
			self.kier = 0;
		end;
	else
		setVisibility(self.index.kierun1, false);
	end;
	if self.kierun2 then
		self.kier2 = self.kier2+1;
		if self.kier2 == 20	then
			setVisibility(self.index.kierun2, true);
		elseif self.kier2 == 40 then
			setVisibility(self.index.kierun2, false);
			self.kier2 = 0;
		end;
	else
		setVisibility(self.index.kierun2, false);
	end;
	
	if self.halogen1 then
		setVisibility(self.index.halogen1, true);
	else
		setVisibility(self.index.halogen1, false);
	end;
	if self.halogen2 then
		setVisibility(self.index.halogen2, true);
	else
		setVisibility(self.index.halogen2, false);
	end;
	
	if self.szybka then
		if x8 < 0.79 then
			setRotation(self.index.szyby, x8+0.01, y8, z8);
		end;
	else
		if x8 > 0 then
			setRotation(self.index.szyby, x8-0.01, y8, z8);
		end;
	end;
end;

function MAT:draw()
	g_currentMission:addExtraPrintText("Klawisz: NUM_0                                POMOC");
	if self.pomoc then		
		setTextColor(0,1,0,1);
		setTextBold(true);
		renderText(0, 0.64, 0.02, "By -> MaTiOs95 & Radex96");
		
		setTextBold(false);
		
		setTextColor(0,1,0,1);
		renderText(0, 0.60, 0.02, "------------>--KLAWISZOLOGIA--<-----------");
		
		setTextColor(1,1,0,1);
		renderText(0, 0.58, 0.02, "Klawisz Num Enter: Odpal/Zgas ciagnik");
		renderText(0, 0.56, 0.02, "Klawisz Num 1: Lewy kierunkowzkaz");
		renderText(0, 0.54, 0.02, "Klawisz Num 3: Prawy kierunkowzkaz");
		renderText(0, 0.52, 0.02, "Klawisz Num 4: Otworz/Zamknij lewe drzwi");
		renderText(0, 0.50, 0.02, "Klawisz Num 5: Otworz/Zamknij szybe");
		renderText(0, 0.48, 0.02, "Klawisz Num 6: Otworz/Zamknij prawe drzwi");
		renderText(0, 0.46, 0.02, "Klawisz Num 8: Wlacz/Wylacz przednie swiatla halogenowe");
		renderText(0, 0.44, 0.02, "Klawisz Num 9: Wlacz/Wylacz tylne swiatla halogenowe");
		
		setTextColor(0,1,0,1);
		setTextBold(true);
		renderText(0, 0.40, 0.02, "Zapraszamy --> WWW.POLSKI-MOD.CBA.PL");
	end;
end;

function MAT:onLeave()
	self:stopMotor();
end;

function MAT:onEnter()
end;

function MAT:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;